## glibc 2.24

=== conform/Makefile ===
# Copyright (C) 1999-2016 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

#
#	Sub-makefile for conform portion of the library.
#
subdir	:= conform

include ../Makeconfig

conformtest-headers-data := $(wildcard data/*.h-data) \
			    $(wildcard data/*/*.h-data)

conformtest-standards := ISO ISO99 ISO11 POSIX XPG3 XPG4 UNIX98 XOPEN2K \
			 POSIX2008 XOPEN2K8

conformtest-headers-ISO := assert.h ctype.h errno.h float.h limits.h locale.h \
			   math.h setjmp.h signal.h stdarg.h stddef.h stdio.h \
			   stdlib.h string.h time.h
conformtest-headers-ISO99 := $(conformtest-headers-ISO) complex.h fenv.h \
			     inttypes.h iso646.h stdbool.h stdint.h tgmath.h \
			     wchar.h wctype.h
# Missing ISO11 expectations for: stdatomic.h threads.h.
conformtest-headers-ISO11 := $(conformtest-headers-ISO99) stdalign.h \
			     stdnoreturn.h uchar.h
conformtest-headers-POSIX := $(conformtest-headers-ISO) aio.h dirent.h \
			     fcntl.h fnmatch.h glob.h grp.h mqueue.h \
			     pthread.h pwd.h regex.h sched.h semaphore.h \
			     sys/mman.h sys/stat.h sys/times.h sys/types.h \
			     sys/utsname.h sys/wait.h tar.h termios.h \
			     unistd.h utime.h wordexp.h
# Missing XPG3 expectations for: regexp.h wchar.h.
conformtest-headers-XPG3 := $(conformtest-headers-ISO) cpio.h dirent.h \
			    fcntl.h fnmatch.h ftw.h glob.h grp.h iconv.h \
			    langinfo.h monetary.h nl_types.h pwd.h regex.h \
			    search.h sys/ipc.h sys/msg.h sys/sem.h sys/shm.h \
			    sys/stat.h sys/times.h sys/types.h sys/utsname.h \
			    sys/wait.h tar.h termios.h ulimit.h unistd.h \
			    utime.h varargs.h wordexp.h
# Missing XPG4 expectations for: re_comp.h regexp.h wchar.h.
# XPG4 includes XTI, but xti.h is outside the scope of these tests.
conformtest-headers-XPG4 := $(conformtest-headers-XPG3) arpa/inet.h fmtmsg.h \
			    libgen.h ndbm.h netdb.h netinet/in.h poll.h \
			    strings.h stropts.h sys/mman.h sys/resource.h \
			    sys/socket.h sys/statvfs.h sys/time.h sys/timeb.h \
			    sys/uio.h sys/un.h syslog.h ucontext.h utmpx.h
# Missing UNIX98 expectations for: inttypes.h re_comp.h regexp.h.
# The online UNIX98 includes XCURSES, but curses.h, term.h and
# unctrl.h are outside the scope of these tests.  It also includes
# XTI, but xti.h is outside the scope of these tests.
conformtest-headers-UNIX98 := $(conformtest-headers-POSIX) arpa/inet.h cpio.h \
			      dlfcn.h fmtmsg.h ftw.h iconv.h iso646.h \
			      langinfo.h libgen.h monetary.h ndbm.h netdb.h \
			      netinet/in.h nl_types.h poll.h search.h \
			      strings.h stropts.h sys/ipc.h sys/msg.h \
			      sys/resource.h sys/sem.h sys/shm.h sys/socket.h \
			      sys/statvfs.h sys/time.h sys/timeb.h sys/uio.h \
			      sys/un.h syslog.h ucontext.h ulimit.h utmpx.h \
			      varargs.h wchar.h wctype.h
# Missing XOPEN2K expectations for: trace.h.
conformtest-headers-XOPEN2K := $(conformtest-headers-POSIX) arpa/inet.h \
			       complex.h cpio.h dlfcn.h fenv.h fmtmsg.h ftw.h \
			       iconv.h inttypes.h iso646.h langinfo.h \
			       libgen.h monetary.h ndbm.h net/if.h netdb.h \
			       netinet/in.h netinet/tcp.h nl_types.h poll.h \
			       search.h spawn.h stdbool.h stdint.h strings.h \
			       stropts.h sys/ipc.h sys/msg.h sys/resource.h \
			       sys/select.h sys/sem.h sys/shm.h sys/socket.h \
			       sys/statvfs.h sys/time.h sys/timeb.h sys/uio.h \
			       sys/un.h syslog.h tgmath.h ucontext.h ulimit.h \
			       utmpx.h wchar.h wctype.h
# Missing POSIX2008 expectations for: trace.h.
conformtest-headers-POSIX2008 := $(conformtest-headers-POSIX) arpa/inet.h \
				 complex.h cpio.h dlfcn.h fenv.h iconv.h \
				 inttypes.h iso646.h langinfo.h monetary.h \
				 net/if.h netdb.h netinet/in.h netinet/tcp.h \
				 nl_types.h poll.h spawn.h stdbool.h stdint.h \
				 strings.h stropts.h sys/select.h \
				 sys/socket.h sys/statvfs.h sys/un.h tgmath.h \
				 wchar.h wctype.h
# Missing XOPEN2K8 expectations for: trace.h.
conformtest-headers-XOPEN2K8 := $(conformtest-headers-POSIX2008) fmtmsg.h \
				ftw.h libgen.h ndbm.h search.h sys/ipc.h \
				sys/msg.h sys/resource.h sys/sem.h sys/shm.h \
				sys/time.h sys/uio.h syslog.h ulimit.h utmpx.h

conformtest-header-list-base := $(foreach std,$(conformtest-standards),\
					      header-list-$(std).out)
conformtest-header-list-tests := $(addprefix $(objpfx),\
					     $(conformtest-header-list-base))
tests-special += $(conformtest-header-list-tests)
generated += $(conformtest-header-list-base)

conformtest-header-base := $(foreach std,\
				     $(conformtest-standards),\
				     $(foreach h,\
					       $(conformtest-headers-$(std)),\
					       $(std)/$(h)/conform.out))
conformtest-header-tests := $(addprefix $(objpfx),$(conformtest-header-base))
ifneq (yes,$(fast-check))
ifeq (no,$(cross-compiling))
tests-special += $(conformtest-header-tests)
generated += $(conformtest-header-base)
endif
endif

linknamespace-symlists-base := $(foreach std,$(conformtest-standards),\
					     symlist-$(std))
linknamespace-symlists-tests := $(addprefix $(objpfx),\
					    $(linknamespace-symlists-base))
tests-special += $(linknamespace-symlists-tests)

linknamespace-symlist-stdlibs-base := $(foreach std,$(conformtest-standards),\
						    symlist-stdlibs-$(std))
linknamespace-symlist-stdlibs-tests := \
	$(addprefix $(objpfx),\
		    $(linknamespace-symlist-stdlibs-base))

tests-special += $(linknamespace-symlist-stdlibs-tests)

linknamespace-header-base := $(foreach std,\
				       $(conformtest-standards),\
				       $(foreach h,\
						 $(conformtest-headers-$(std)),\
						 $(std)/$(h)/linknamespace.out))
linknamespace-header-tests := $(addprefix $(objpfx),\
					  $(linknamespace-header-base))
tests-special += $(linknamespace-header-tests)

include ../Rules

$(conformtest-header-list-tests): $(objpfx)header-list-%.out: \
				  check-header-lists.sh \
				  $(conformtest-headers-data)
	$(SHELL) $< "$*" "$(CC)" "$(strip $(conformtest-headers-$*))" \
		 "$(conformtest-headers-data)" > $@; \
	$(evaluate-test)

# Pre-standard C feature no longer supported by GCC (obsoleted in
# newer POSIX standards).
test-xfail-XPG3/varargs.h/conform = yes
test-xfail-XPG4/varargs.h/conform = yes
test-xfail-UNIX98/varargs.h/conform = yes

# Header not provided by glibc.
test-xfail-XPG4/ndbm.h/conform = yes
test-xfail-UNIX98/ndbm.h/conform = yes
test-xfail-XOPEN2K/ndbm.h/conform = yes
test-xfail-XOPEN2K8/ndbm.h/conform = yes

# Unsorted expected failures.
test-xfail-XPG3/signal.h/conform = yes
test-xfail-XPG3/sys/wait.h/conform = yes
test-xfail-XPG4/arpa/inet.h/conform = yes
test-xfail-XPG4/netdb.h/conform = yes
test-xfail-XPG4/netinet/in.h/conform = yes
test-xfail-XPG4/signal.h/conform = yes
test-xfail-XPG4/sys/wait.h/conform = yes
test-xfail-XPG4/ucontext.h/conform = yes
test-xfail-POSIX/sys/wait.h/conform = yes
test-xfail-UNIX98/arpa/inet.h/conform = yes
test-xfail-UNIX98/netdb.h/conform = yes
test-xfail-UNIX98/netinet/in.h/conform = yes
test-xfail-UNIX98/signal.h/conform = yes
test-xfail-UNIX98/sys/wait.h/conform = yes
test-xfail-UNIX98/ucontext.h/conform = yes
test-xfail-XOPEN2K/semaphore.h/conform = yes
test-xfail-XOPEN2K/signal.h/conform = yes
test-xfail-XOPEN2K/sys/wait.h/conform = yes
test-xfail-XOPEN2K/ucontext.h/conform = yes
test-xfail-POSIX2008/arpa/inet.h/conform = yes
test-xfail-POSIX2008/netdb.h/conform = yes
test-xfail-POSIX2008/netinet/in.h/conform = yes
test-xfail-POSIX2008/signal.h/conform = yes
test-xfail-POSIX2008/sys/socket.h/conform = yes
test-xfail-POSIX2008/sys/wait.h/conform = yes
test-xfail-XOPEN2K8/signal.h/conform = yes
test-xfail-XOPEN2K8/sys/wait.h/conform = yes

conformtest-cc-flags = -I../include $(+sysdep-includes) $(sysincludes) -I..
$(conformtest-header-tests): $(objpfx)%/conform.out: \
			     conformtest.pl $(conformtest-headers-data)
	(set -e; std_hdr=$*; std=$${std_hdr%%/*}; hdr=$${std_hdr#*/}; \
	 mkdir -p $(@D)/scratch; \
	 $(PERL) conformtest.pl --tmpdir=$(@D)/scratch --cc='$(CC)' \
		 --flags='$(conformtest-cc-flags)' --standard=$$std \
		 --headers=$$hdr > $@); \
	$(evaluate-test)

$(linknamespace-symlists-tests): $(objpfx)symlist-%: list-header-symbols.pl
	$(PERL) -w $< --tmpdir=$(objpfx) --cc='$(CC)' \
		--flags='$(conformtest-cc-flags)' --standard=$* \
		--headers="$(strip $(conformtest-headers-$*))" \
		> $@ 2> $@.err; \
	$(evaluate-test)

linknamespace-libs-isoc = $(common-objpfx)libc.a $(common-objpfx)math/libm.a
linknamespace-libs = $(linknamespace-libs-isoc) \
		     $(common-objpfx)rt/librt.a $(static-thread-library)
linknamespace-libs-ISO = $(linknamespace-libs-isoc)
linknamespace-libs-ISO99 = $(linknamespace-libs-isoc)
linknamespace-libs-ISO11 = $(linknamespace-libs-isoc)
linknamespace-libs-XPG3 = $(linknamespace-libs-isoc)
linknamespace-libs-XPG4 = $(linknamespace-libs-isoc)
linknamespace-libs-POSIX = $(linknamespace-libs)
linknamespace-libs-UNIX98 = $(linknamespace-libs)
linknamespace-libs-XOPEN2K = $(linknamespace-libs)
linknamespace-libs-POSIX2008 = $(linknamespace-libs)
linknamespace-libs-XOPEN2K8 = $(linknamespace-libs)

$(linknamespace-symlist-stdlibs-tests): $(objpfx)symlist-stdlibs-%: \
					$(linknamespace-libs)
	LC_ALL=C $(READELF) -W -s $(linknamespace-libs-$*) > $@; \
	$(evaluate-test)

$(linknamespace-header-tests): $(objpfx)%/linknamespace.out: \
			       linknamespace.pl \
			       $(linknamespace-symlist-stdlibs-tests)
	(set -e; std_hdr=$*; std=$${std_hdr%%/*}; hdr=$${std_hdr#*/}; \
	 mkdir -p $(@D)/scratch; \
	 $(PERL) -w $< --tmpdir=$(@D)/scratch --cc='$(CC)' \
		 --flags='$(conformtest-cc-flags)' --standard=$$std \
		 --stdsyms=$(objpfx)symlist-$$std --header=$$hdr \
		 --libsyms=$(objpfx)symlist-stdlibs-$$std \
		 --readelf='$(READELF)' \
		 > $@ 2>&1); \
	$(evaluate-test)

# Pre-standard C feature no longer supported by GCC (obsoleted in
# newer POSIX standards).
test-xfail-XPG3/varargs.h/linknamespace = yes
test-xfail-XPG4/varargs.h/linknamespace = yes
test-xfail-UNIX98/varargs.h/linknamespace = yes

# Header not provided by glibc.
test-xfail-XPG4/ndbm.h/linknamespace = yes
test-xfail-UNIX98/ndbm.h/linknamespace = yes
test-xfail-XOPEN2K/ndbm.h/linknamespace = yes
test-xfail-XOPEN2K8/ndbm.h/linknamespace = yes

=== gmon/Makefile ===
# Copyright (C) 1995-2016 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

#
#	Sub-makefile for gmon portion of the library.
#
subdir	:= gmon

include ../Makeconfig

headers	:= sys/gmon.h sys/gmon_out.h sys/profil.h
routines := gmon mcount profil sprofil bb_init_func bb_exit_func prof-freq

elide-routines.os = bb_init_func bb_exit_func

tests	= tst-sprofil
ifeq ($(build-profile),yes)
tests	+= tst-profile-static
tests-static	+= tst-profile-static

LDFLAGS-tst-profile-static = -profile
endif

# The mcount code won't work without a frame pointer.
CFLAGS-mcount.c := -fno-omit-frame-pointer

include ../Rules

# We cannot compile mcount.c with -pg because that would
# create recursive calls.  Just copy the normal static object.
# On systems where `profil' is not a system call, the same
# problem exists for the internal functions in profil.c.

noprof := mcount $(sysdep_noprof)
ifeq (,$(filter profil,$(unix-syscalls)))
noprof += profil sprofil
endif

$(noprof:%=$(objpfx)%.op): %.op: %.o
	rm -f $@
	ln $< $@

=== iconvdata/Makefile ===
# Copyright (C) 1997-2016 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

#
#	Makefile for iconv data and code.
#
subdir	:= iconvdata

include ../Makeconfig

# Names of all the shared objects which implement the transformations.
modules	:= ISO8859-1 ISO8859-2 ISO8859-3 ISO8859-4 ISO8859-5		 \
	   ISO8859-6 ISO8859-7 ISO8859-8 ISO8859-9 ISO8859-10		 \
	   ISO8859-11 ISO8859-13 ISO8859-14 ISO8859-15 ISO8859-16	 \
	   T.61 ISO_6937 SJIS KOI-8 HP-ROMAN8 HP-ROMAN9 EBCDIC-AT-DE	 \
	   EBCDIC-AT-DE-A EBCDIC-CA-FR EUC-KR UHC JOHAB libJIS libKSC	 \
	   BIG5 EUC-JP libGB EUC-CN libCNS EUC-TW ISO646 EBCDIC-DK-NO	 \
	   EBCDIC-DK-NO-A EBCDIC-ES EBCDIC-ES-A EBCDIC-ES-S EBCDIC-FI-SE \
	   EBCDIC-FI-SE-A EBCDIC-FR EBCDIC-IS-FRISS EBCDIC-IT EBCDIC-PT	 \
	   EBCDIC-UK EBCDIC-US IBM037 IBM038 IBM274 IBM275 IBM423	 \
	   IBM500 IBM870 IBM871 IBM891 IBM903 IBM904 IBM905 IBM1047	 \
	   IBM874 CP737 CP775 ISO-2022-KR HP-TURKISH8 HP-THAI8 HP-GREEK8 \
	   KOI8-R LATIN-GREEK LATIN-GREEK-1 IBM256 IBM273 IBM277 IBM278	 \
	   IBM280 IBM281 IBM284 IBM285 IBM290 IBM297 IBM420 IBM424	 \
	   IBM437 IBM850 IBM851 IBM852 IBM855 IBM857 IBM860 IBM861	 \
	   IBM862 IBM863 IBM864 IBM865 IBM868 IBM869 IBM875 IBM880	 \
	   IBM866 CP1258 IBM922 IBM1124 IBM1129 IBM932 IBM943		 \
	   IBM856 IBM930 IBM933 IBM935 IBM937 IBM939 IBM1046		 \
	   IBM1132 IBM1133 IBM1160 IBM1161 IBM1162 IBM1163 IBM1164	 \
	   IBM918 IBM1004 IBM1026 CP1125 CP1250 CP1251 CP1252 CP1253	 \
	   CP1254 CP1255 CP1256 CP1257 ISO-2022-JP MACINTOSH IEC_P27-1	 \
	   ASMO_449 ANSI_X3.110 CSN_369103 CWI DEC-MCS ECMA-CYRILLIC	 \
	   GOST_19768-74 GREEK-CCITT GREEK7 GREEK7-OLD INIS INIS-8	 \
	   INIS-CYRILLIC ISO_6937-2 ISO_2033 ISO_5427 ISO_5427-EXT	 \
	   ISO_5428 ISO_10367-BOX MAC-IS MAC-UK NATS-DANO NATS-SEFI	 \
	   SAMI-WS2 ISO-IR-197 TIS-620 KOI8-U GBK ISIRI-3342 GBGBK	 \
	   ISO-2022-CN libISOIR165 UTF-16 UNICODE UTF-32 UTF-7 BIG5HKSCS \
	   GB18030 ISO-2022-CN-EXT VISCII GBBIG5 CP10007 KOI8-T		 \
	   GEORGIAN-PS GEORGIAN-ACADEMY ISO-IR-209 MAC-SAMI ARMSCII-8	 \
	   TCVN5712-1 libJISX0213 EUC-JISX0213 SHIFT_JISX0213		 \
	   ISO-2022-JP-3 TSCII IBM866NAV CP932 EUC-JP-MS PT154 RK1048	 \
	   IBM1025 IBM1122 IBM1137 IBM1153 IBM1154 IBM1155 IBM1156	 \
	   IBM1157 IBM1158 IBM803 IBM901 IBM902 IBM921 IBM1008		 \
	   IBM1008_420 IBM1097 IBM1112 IBM1123 IBM1130 IBM1140 IBM1141	 \
	   IBM1142 IBM1143 IBM1144 IBM1145 IBM1146 IBM1147 IBM1148	 \
	   IBM1149 IBM1166 IBM1167 IBM4517 IBM4899 IBM4909 IBM4971	 \
	   IBM5347 IBM9030 IBM9066 IBM9448 IBM12712 IBM16804             \
	   IBM1364 IBM1371 IBM1388 IBM1390 IBM1399 ISO_11548-1 MIK BRF	 \
	   MAC-CENTRALEUROPE KOI8-RU ISO8859-9E				 \
	   CP770 CP771 CP772 CP773 CP774

modules.so := $(addsuffix .so, $(modules))

ifeq (yes,$(build-shared))
tests = bug-iconv1 bug-iconv2 tst-loading tst-e2big tst-iconv4 bug-iconv4 \
	tst-iconv6 bug-iconv5 bug-iconv6 tst-iconv7 bug-iconv8 bug-iconv9 \
	bug-iconv10 bug-iconv11 bug-iconv12
ifeq ($(have-thread-library),yes)
tests += bug-iconv3
endif

test-srcs := tst-table-from tst-table-to
endif

libJIS-routines := jis0201 jis0208 jis0212
libKSC-routines := ksc5601
libGB-routines := gb2312
libCNS-routines := cns11643l1 cns11643
libISOIR165-routines := iso-ir-165
libJISX0213-routines := jisx0213

LDFLAGS-EUC-KR.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-KR.so: $(objpfx)libKSC.so
LDFLAGS-JOHAB.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)JOHAB.so: $(objpfx)libKSC.so
LDFLAGS-UHC.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)UHC.so: $(objpfx)libKSC.so
LDFLAGS-EUC-JP.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-JP.so: $(objpfx)libJIS.so
LDFLAGS-EUC-JP-MS.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-JP-MS.so: $(objpfx)libJIS.so
LDFLAGS-EUC-CN.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-CN.so: $(objpfx)libGB.so
LDFLAGS-EUC-TW.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-TW.so: $(objpfx)libCNS.so
LDFLAGS-EUC-JISX0213.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)EUC-JISX0213.so: $(objpfx)libJISX0213.so
LDFLAGS-SHIFT_JISX0213.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)SHIFT_JISX0213.so: $(objpfx)libJISX0213.so

LDFLAGS-ISO-2022-JP.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-JP.so: $(objpfx)libJIS.so $(objpfx)libGB.so \
			 $(objpfx)libCNS.so $(objpfx)libKSC.so
LDFLAGS-ISO-2022-JP-3.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-JP-3.so: $(objpfx)libJIS.so $(objpfx)libJISX0213.so
LDFLAGS-ISO-2022-KR.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-KR.so: $(objpfx)libKSC.so
LDFLAGS-ISO-2022-CN.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-CN.so: $(objpfx)libGB.so $(objpfx)libCNS.so
LDFLAGS-ISO-2022-CN-EXT.so = $(LDFLAGS-rpath-ORIGIN)
$(objpfx)ISO-2022-CN-EXT.so: $(objpfx)libGB.so $(objpfx)libCNS.so \
			     $(objpfx)libISOIR165.so

LDFLAGS-libJIS.so = $(LDFLAGS-soname-fname)
LDFLAGS-libKSC.so = $(LDFLAGS-soname-fname)
LDFLAGS-libGB.so = $(LDFLAGS-soname-fname)
LDFLAGS-libCNS.so = $(LDFLAGS-soname-fname)
LDFLAGS-libISOIR165.so = $(LDFLAGS-soname-fname)
LDFLAGS-libJISX0213.so = $(LDFLAGS-soname-fname)

# We build the transformation modules only when we build shared libs.
ifeq (yes,$(build-shared))

# Rule to generate the shared objects.
charmaps = ../localedata/charmaps
-include $(objpfx)iconv-rules
extra-modules-left := $(modules)
include extra-module.mk


extra-objs	+= $(modules.so)
install-others	= $(addprefix $(inst_gconvdir)/, $(modules.so))	\
		  $(inst_gconvdir)/gconv-modules

# We can build the conversion tables for numerous charsets automatically.

gen-8bit-modules := iso8859-2 iso8859-3 iso8859-4 iso8859-6 iso8859-9 koi-8 \
		    ebcdic-at-de ebcdic-at-de-a ebcdic-ca-fr ebcdic-dk-no   \
		    ebcdic-dk-no-a ebcdic-es-s ebcdic-fi-se ebcdic-fi-se-a  \
		    ebcdic-fr ebcdic-it ebcdic-pt ebcdic-us \
		    ibm037 ibm038 ibm274 ibm275 ibm423 ibm500 ibm870 ibm871 \
		    ibm891 ibm903 ibm904 ibm905 ibm1047

gen-8bit-gap-modules := koi8-r latin-greek latin-greek-1 ibm256 ibm273	   \
			ibm277 ibm278 ibm280 ibm281 ibm284 ibm285 ibm290   \
			ibm297 ibm420 ibm424 ibm437 ibm850 ibm851 ibm852   \
			ibm855 ibm857 ibm860 ibm861 ibm862 ibm863 ibm864   \
			ibm865 ibm868 ibm869 ibm875 ibm880 ibm918 ibm1004  \
			ibm1026 cp1125 cp1250 cp1251 cp1252 cp1253 cp1254  \
			cp1256 cp1257 ibm866 iso8859-5 iso8859-7 iso8859-8 \
			iso8859-10 macintosh iec_p27-1 asmo_449		   \
			csn_369103 cwi dec-mcs ecma-cyrillic gost_19768-74 \
			greek-ccitt greek7 greek7-old inis inis-8	   \
			inis-cyrillic iso_2033 iso_5427 iso_5427-ext	   \
			iso_5428 iso_10367-box mac-is nats-dano nats-sefi  \
			iso8859-13 iso8859-14 iso8859-15 mac-uk sami-ws2   \
			iso-ir-197 tis-620 koi8-u ibm874 cp10007 koi8-t	   \
			georgian-ps georgian-academy iso-ir-209 mac-sami   \
			iso8859-11 ibm866nav pt154 rk1048 mik brf	   \
			mac-centraleurope koi8-ru hp-roman8 hp-roman9	   \
			ebcdic-es ebcdic-es-a ebcdic-is-friss ebcdic-uk    \
			iso8859-16 viscii iso8859-9e hp-turkish8	   \
			hp-thai8 hp-greek8 cp770 cp771 cp772 cp773 cp774


gen-special-modules := iso8859-7jp

generated-modules := $(gen-8bit-modules) $(gen-8bit-gap-modules) \
		     $(gen-special-modules)

generated += $(generated-modules:=.h) $(generated-modules:=.stmp) \
	     iconv-test.out iconv-rules tst-loading.mtrace	 \
	     mtrace-tst-loading.out tst-tables.out iconv-test.xxx
ifdef objpfx
generated += gconv-modules
endif

# Rules to generate the headers.
export AWK

define generate-8bit-table
$(make-target-directory)
LC_ALL=C $(SHELL) ./gen-8bit.sh $< > $(@:stmp=T)
$(move-if-change) $(@:stmp=T) $(@:stmp=h)
touch $@
endef

define generate-8bit-gap-table
$(make-target-directory)
LC_ALL=C $(SHELL) ./gen-8bit-gap.sh $< > $(@:stmp=T)
$(move-if-change) $(@:stmp=T) $(@:stmp=h)
touch $@
endef

# The headers must be generated before the compilation.
before-compile += $(addprefix $(objpfx),$(generated-modules:=.h))

ifndef avoid-generated
$(objpfx)iconv-rules: Makefile
	$(make-target-directory)
	{ echo $(filter-out lib%, $(modules)); \
	  echo 8bit $(gen-8bit-modules); \
	  echo 8bit-gap $(gen-8bit-gap-modules); } | \
	LC_ALL=C \
	$(AWK) 'NR == 1 { \
		  for (i = 1; i <= NF; i++) { \
		    printf "%s-routines := %s\n", $$i, tolower($$i); \
		    printf "libof-%s := iconvdata\n", tolower($$i); \
		    printf "%s-map := gconv.map\n", $$i; \
		  } \
		}; \
		NR > 1 { \
		  for (i = 2; i <= NF; i++) { \
		    printf "$$(objpfx)%s.stmp: ", $$i; \
		    map = toupper($$i); \
		    sub(/^ISO8859/, "ISO-8859", map); \
		    if (map == "ISO_2033") map = map "-1983"; \
		    printf "$$(charmaps)/%s ", map; \
		    printf "gen-%s.sh\n", $$1; \
		    printf "\t$$(generate-%s-table)\n", $$1; \
		  } \
		}' > $@.new
	mv -f $@.new $@
endif

$(generated-modules:%=$(objpfx)%.h): $(objpfx)%.h: $(objpfx)%.stmp
	@:

$(gen-8bit-modules:%=$(objpfx)%.stmp): $(objpfx)%.stmp: $(objpfx)iconv-rules
$(gen-8bit-gap-modules:%=$(objpfx)%.stmp): $(objpfx)%.stmp: $(objpfx)iconv-rules

$(objpfx)iso8859-7jp.stmp: $(charmaps)/ISO-8859-7 gen-8bit-gap-1.sh
	$(make-target-directory)
	LC_ALL=C $(SHELL) ./gen-8bit-gap-1.sh $< > $(@:stmp=T)
	$(move-if-change) $(@:stmp=T) $(@:stmp=h)
	touch $@

headers: $(addprefix $(objpfx), $(generated-modules:=.h))

$(addprefix $(inst_gconvdir)/, $(modules.so)): \
    $(inst_gconvdir)/%: $(objpfx)% $(+force)
	$(do-install-program)
$(inst_gconvdir)/gconv-modules: $(objpfx)gconv-modules $(+force)
	$(do-install)
ifeq (no,$(cross-compiling))
# Update the $(prefix)/lib/gconv/gconv-modules.cache file. This is necessary
# if this libc has more gconv modules than the previously installed one.
	if test -f "$(inst_gconvdir)/gconv-modules.cache"; then \
	   LC_ALL=C \
	   $(rtld-prefix) \
	   $(common-objpfx)iconv/iconvconfig \
	     $(addprefix --prefix=,$(install_root)); \
	fi
else
	@echo '*@*@*@ You should recreate $(inst_gconvdir)/gconv-modules.cache'
endif

endif # build-shared = yes

ifeq ($(run-built-tests),yes)
ifeq (yes,$(build-shared))
tests-special += $(objpfx)iconv-test.out $(objpfx)tst-tables.out
ifneq (no,$(PERL))
tests-special += $(objpfx)mtrace-tst-loading.out
endif
endif
endif

include ../Rules

ifeq ($(run-built-tests),yes)
LOCALES := de_DE.UTF-8
include ../gen-locales.mk

$(objpfx)bug-iconv6.out: $(gen-locales)
$(objpfx)tst-iconv7.out: $(gen-locales)
endif

# Set libof-* for each routine.
cpp-srcs-left := $(modules) $(generated-modules) $(libJIS-routines) \
		 $(libKSC-routines) $(libGB-routines) $(libCNS-routines) \
		 $(libISOIR165-routines) $(libJISX0213-routines)
lib := iconvdata
include $(patsubst %,$(..)cppflags-iterator.mk,$(cpp-srcs-left))

tst-loading-ENV = MALLOC_TRACE=$(objpfx)tst-loading.mtrace
$(objpfx)mtrace-tst-loading.out: $(objpfx)tst-loading.out
	$(common-objpfx)malloc/mtrace $(objpfx)tst-loading.mtrace > $@; \
	$(evaluate-test)

$(objpfx)bug-iconv1.out: $(objpfx)gconv-modules \
			 $(addprefix $(objpfx),$(modules.so))
$(objpfx)bug-iconv2.out: $(objpfx)gconv-modules \
			 $(addprefix $(objpfx),$(modules.so))
$(objpfx)bug-iconv3: $(libdl)
$(objpfx)bug-iconv3.out: $(objpfx)gconv-modules \
			 $(addprefix $(objpfx),$(modules.so))
$(objpfx)bug-iconv5.out: $(objpfx)gconv-modules \
			 $(addprefix $(objpfx),$(modules.so))
$(objpfx)tst-loading.out: $(objpfx)gconv-modules \
			  $(addprefix $(objpfx),$(modules.so))
$(objpfx)tst-iconv4.out: $(objpfx)gconv-modules \
			 $(addprefix $(objpfx),$(modules.so))
$(objpfx)tst-iconv7.out: $(objpfx)gconv-modules \
			 $(addprefix $(objpfx),$(modules.so))

=== nscd/Makefile ===
# Copyright (C) 1998-2016 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library; if not, see
# <http://www.gnu.org/licenses/>.

#
#	Sub-makefile for nscd portion of the library.
#
subdir	:= nscd

include ../Makeconfig

ifneq ($(use-nscd),no)
routines := nscd_getpw_r nscd_getgr_r nscd_gethst_r nscd_getai \
	    nscd_initgroups nscd_getserv_r nscd_netgroup
aux	:= nscd_helper
endif

# To find xmalloc.c
vpath %.c ../locale/programs

nscd-modules := nscd connections pwdcache getpwnam_r getpwuid_r grpcache \
		getgrnam_r getgrgid_r hstcache gethstbyad_r gethstbynm3_r \
		getsrvbynm_r getsrvbypt_r servicescache \
		dbg_log nscd_conf nscd_stat cache mem nscd_setup_thread \
		xmalloc xstrdup aicache initgrcache gai res_hconf \
		netgroupcache

ifeq ($(build-nscd)$(have-thread-library),yesyes)

others += nscd
others-pie += nscd
install-sbin := nscd

extra-objs = $(nscd-modules:=.o)

endif

all-nscd-modules := $(nscd-modules) selinux
ifeq (yes,$(have-selinux))
ifeq (yes,$(have-libaudit))
libaudit = -laudit
ifeq (yes,$(have-libcap))
libcap = -lcap
endif
endif

nscd-modules += selinux
selinux-LIBS := -lselinux $(libaudit) $(libcap)

# The configure.ac check for libselinux and its headers did not use
# $SYSINCLUDES.  The directory specified by --with-headers usually
# contains only the basic kernel interface headers, not something like
# libselinux.  So the simplest thing is to presume that the standard
# system headers will be ok for this file.
$(objpfx)nscd_stat.o: sysincludes = # nothing
$(objpfx)selinux.o: sysincludes = # nothing
endif

LDLIBS-nscd = $(selinux-LIBS)

include ../Rules

CFLAGS-nscd_getpw_r.c = -fexceptions
CFLAGS-nscd_getgr_r.c = -fexceptions
CFLAGS-nscd_gethst_r.c = -fexceptions
CFLAGS-nscd_getai.c = -fexceptions
CFLAGS-nscd_initgroups.c = -fexceptions

CPPFLAGS-nscd += -D_FORTIFY_SOURCE=2

ifeq (yesyes,$(have-fpie)$(build-shared))
CFLAGS-nscd += $(pie-ccflag)
endif
CFLAGS-nscd += $(stack-protector)

ifeq (yesyes,$(have-fpie)$(build-shared))
LDFLAGS-nscd = -Wl,-z,now
endif

# Set libof-nscd.
cpp-srcs-left := $(nscd-modules)
lib := nscd
include $(patsubst %,$(..)cppflags-iterator.mk,$(cpp-srcs-left))

$(objpfx)nscd: $(nscd-modules:%=$(objpfx)%.o)

ifeq ($(build-shared),yes)
$(objpfx)nscd: $(shared-thread-library) $(common-objpfx)nis/libnsl.so
else
$(objpfx)nscd: $(static-thread-library) $(common-objpfx)nis/libnsl.a
endif

=== sysdeps/hppa/Makefile ===
# Copyright (C) 2000-2016 Free Software Foundation, Inc.
# This file is part of the GNU C Library.
# Contributed by David Huggins-Daines (dhd@debian.org)

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2.1 of the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with the GNU C Library.  If not, see
# <http://www.gnu.org/licenses/>.

# We used to need this since the build process uses ld -r.  Now we use
# ld -r --unique=.text* which does more or less the same thing, but better.
# CFLAGS-.os += -ffunction-sections
LDFLAGS-c_pic.os += -Wl,--unique=.text*

ifeq ($(subdir),elf)
CFLAGS-rtld.c += -mdisable-fpregs
sysdep-dl-routines += dl-symaddr dl-fptr
# dl-fptr.c needs a complete rewrite to fix ISO C aliasing violations.
CFLAGS-dl-fptr.c = -Wno-error
endif

ifeq ($(subdir),csu)
ifeq (yes,$(build-shared))
# Compatibility
ifeq (yes,$(have-protected))
CPPFLAGS-libgcc-compat.c = -DHAVE_DOT_HIDDEN
endif
sysdep_routines += libgcc-compat
shared-only-routines += libgcc-compat
endif
endif

# We implement a 64-bit `long double'. The standard says we can do this.
# This means our `long double' and `double' are identical.
long-double-fcts = no

=== sysdeps/i386/i686/Makefile ===
# So that we can test __m128's alignment
stack-align-test-flags += -msse

CFLAGS-.o += -Wa,-mtune=i686
CFLAGS-.os += -Wa,-mtune=i686
CFLAGS-.op += -Wa,-mtune=i686
CFLAGS-.og += -Wa,-mtune=i686
CFLAGS-.oS += -Wa,-mtune=i686

ASFLAGS-.o += -Wa,-mtune=i686
ASFLAGS-.os += -Wa,-mtune=i686
ASFLAGS-.op += -Wa,-mtune=i686
ASFLAGS-.og += -Wa,-mtune=i686
ASFLAGS-.oS += -Wa,-mtune=i686

=== sysdeps/sparc/sparc64/fpu/multiarch/Makefile ===
ifeq ($(subdir),math)
ifeq ($(have-as-vis3),yes)
libm-sysdep_routines += m_signbitf-vis3 m_signbit-vis3 m_finitef-vis3 \
			m_finite-vis3 m_isinff-vis3 m_isinf-vis3 \
			m_isnanf-vis3 m_isnan-vis3 s_lrintf-vis3 \
			s_lrint-vis3 s_rintf-vis3 s_rint-vis3 \
			s_fminf-vis3 s_fmin-vis3 s_fmaxf-vis3 \
			s_fmax-vis3 s_fmaf-vis3 s_fma-vis3 \
			s_nearbyint-vis3 s_nearbyintf-vis3
sysdep_routines += s_signbitf-vis3 s_signbit-vis3 s_finitef-vis3 \
		   s_finite-vis3 s_isinff-vis3 s_isinf-vis3 \
		   s_isnanf-vis3 s_isnan-vis3
endif
endif

=== sysdeps/unix/sysv/linux/microblaze/Makefile ===
ifeq ($(subdir),resource)
sysdep_routines += backtrace_linux
endif

ifeq ($(subdir),nptl)
# pull in __syscall_error routine
libpthread-routines += sysdep
endif

=== sysdeps/sparc/sparc32/sparcv9/fpu/multiarch/Makefile ===
ifeq ($(subdir),math)
ifeq ($(have-as-vis3),yes)
libm-sysdep_routines += m_copysignf-vis3 m_copysign-vis3 s_fabs-vis3 \
			s_fabsf-vis3 s_llrintf-vis3 s_llrint-vis3 \
			s_rintf-vis3 s_rint-vis3 w_sqrt-vis3 w_sqrtf-vis3 \
			s_fminf-vis3 s_fmin-vis3 s_fmaxf-vis3 s_fmax-vis3 \
			s_fmaf-vis3 s_fma-vis3 s_fdimf-vis3 s_fdim-vis3 \
			s_nearbyint-vis3 s_nearbyintf-vis3
sysdep_routines += s_copysignf-vis3 s_copysign-vis3
endif
endif

=== debian/changelog ===
glibc (2.24-11+deb9u4) stretch; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix buffer overflow in glob with GLOB_TILDE (CVE-2017-15670).  Closes:
      #879501.
    - Fix memory leak in glob with GLOB_TILDE (CVE-2017-15671).  Closes:
      #879500.
    - Fix a buffer overflow in glob with GLOB_TILDE in unescaping
      (CVE-2017-15804).  Closes: #879955.
    - Fix a memory leak in ld.so (CVE-2017-1000408).  Closes: #884132.
    - Fix a buffer overflow in ld.so (CVE-2017-1000409).  Closes: #884133.
    - Fixes incorrect RPATH/RUNPATH handling for SUID binaries
      (CVE-2017-16997).  Closes: #884615.
    - Fix a data corruption in SSE2-optimized memmove implementation for
      i386 (CVE-2017-18269).
    - Fix a stack-based buffer overflow in the realpath function
      (CVE-2018-11236).  Closes: #899071.
    - Fix a buffer overflow in the AVX-512-optimized implementation of the
      mempcpy function (CVE-2018-11237).  Closes: #899070.
    - Fix stack guard size accounting and reduce stack usage during
      unwinding to avoid segmentation faults on CPUs with AVX512-F.  Closes:
      #903554.
    - Fix a use after free in pthread_create().  Closes: #916925.
  * debian/debhelper.in/libc.postinst, script.in/nsscheck.sh: check for
    postgresql in NSS check.  Closes: #710275.

  [ Sebastian Andrzej Siewior ]
  * patches/any/local-condvar-do-not-use-requeue-for-pshared-condvars.patch:
    patch to fix pthread_cond_wait() in the pshared case on non-x86.  Closes:
    #904158.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 06 Feb 2019 22:17:41 +0100

glibc (2.24-11+deb9u3) stretch; urgency=medium

  [ Aurelien Jarno ]
  * debian/rules.d/debhelper.mk: install the libc-otherbuild postinst and
    postrm in the libc6-i686 transitional package, to make sure
    /etc/ld.so.nohwcap is correctly removed after an upgrade.  Closes:
    #883394.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 14 Jan 2018 11:39:44 +0100

glibc (2.24-11+deb9u2) stretch; urgency=medium

  [ Aurelien Jarno ]
  * debian/control.in/x32: Add a gcc-multilib Recommends for libc6-dev-x32.
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/any/submitted-perl-inc.diff: drop, merged upstream.
    - debian/patches/any/cvs-remove-pid-tid-cache-clone.diff: drop, merged
      upstream.
    - debian/patches/any/local-CVE-2017-1000366-rtld-LD_LIBRARY_PATH.diff:
      drop, merged upstream.
    - debian/patches/any/local-CVE-2017-1000366-rtld-LD_PRELOAD.diff: drop,
      merged upstream.
    - debian/patches/any/local-CVE-2017-1000366-rtld-LD_AUDIT.diff: drop,
      merged upstream.
    - debian/patches/any/cvs-vectorized-strcspn-guards.diff: drop, merged
      upstream.
    - debian/patches/any/cvs-hwcap-AT_SECURE.diff: drop, merged upstream.
    - Avoid use-after-free read access in clntudp_call (CVE-2017-12133).
      Closes: #870648.
    - Fix compatibility with Intel C++ __regcall calling convention.  Closes:
      #881850.
    - Fix a buffer overrun in rpcgen.
    - Fix strlen on null pointer in nss_nisplus.
    - Fix invalid cast in group merging affecting ppc64 and s390x.
    - Define collation for Malayalam chillu characters.
    - Correct collation of U+0D36 and U+0D37 Malayalam characters.
  * debian/script.in/nohwcap.sh: always check for all optimized packages
    as multiarch allows one to install foreign architectures.  Closes:
    #882272.

  [ Santiago Vila ]
  * debian/debhelper.in/libc-bin.postinst: do not update /etc/nsswitch.conf
    when its content already matches the default.  Closes: #865144.

 -- Aurelien Jarno <aurel32@debian.org>  Fri, 01 Dec 2017 21:09:18 +0100

glibc (2.24-11+deb9u1) stretch-security; urgency=medium

  * debian/patches/any/local-CVE-2017-1000366-rtld-LD_AUDIT.diff,
    debian/patches/any/local-CVE-2017-1000366-rtld-LD_LIBRARY_PATH.diff,
    debian/patches/any/local-CVE-2017-1000366-rtld-LD_PRELOAD.diff: add
    patches to protect the dynamic linker against stack clashes
    (CVE-2017-1000366).
  * debian/patches/any/cvs-vectorized-strcspn-guards.diff: patch backported
    from upstream to allow usage of strcspn in ld.so.
  * debian/patches/any/cvs-hwcap-AT_SECURE.diff: patch backported from
    upstream to disable HWCAP for AT_SECURE programs.

 -- Aurelien Jarno <aurel32@debian.org>  Thu, 15 Jun 2017 21:17:14 +0200

glibc (2.24-11) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Improve memcpy/memset performance on Skylake server.
  * debian/patches/any/cvs-malloc-hardening.diff: patch backported from
    upstream to further harden glibc malloc metadata against 1-byte
    overflows.  Closes: #862950.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 28 May 2017 19:29:33 +0200

glibc (2.24-10) unstable; urgency=medium

  [ Samuel Thibault ]
  * hurd-i386/cvs-truncate64.diff: New patch to support 64bit truncate.
  * hurd-i386/cvs-send-recv-posix.diff: New patch to make send/recv more
    posix.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix readahead on mips64el.
    - Improve branch predication in _dl_runtime_resolve_avx512_opt;
    - Fix symbol redirect for fts_set on 32-bit architectures.
    - Fix AVX2/AVX512 optimized unaligned memset.
    - Don't use PLT nor GOT in static archives on amd64.
    - Drop GLIBC_TUNABLES in setxid processes.
    - Fix write-after-destroy in lock elision on powerpc/ppc64el.
  * Drop patches/any/cvs-resolv-internal-qtype.diff, merged upstream.
  * any/cvs-remove-pid-tid-cache-clone.diff: patch from upstream to remove
    cached PID/TID in clone.  Closes: #857909.
  * debian/rules.d/build.mk: do not fail the build in case of testsuite
    regressions when building a +debXuX version. That way changes in the
    environment (e.g.: kernel) do not prevent security or stable versions
    to be built.



=== debian/control ===
Source: glibc
Section: libs
Priority: required
Build-Depends: gettext, dpkg (>= 1.18.7), dpkg-dev (>= 1.17.14), xz-utils, file, quilt,
 autoconf, gawk, debhelper (>= 9.20160709), rdfind, symlinks, netbase,
 linux-libc-dev (>= 3.9) [linux-any],
 libaudit-dev [linux-any], libcap-dev [linux-any], libselinux-dev [linux-any],
 mig (>= 1.5-3) [hurd-i386], gnumach-dev (>= 2:1.8+git20170102-1~) [hurd-i386],
 hurd-dev (>= 1:0.5.git20140320~) [hurd-i386] | hurd-headers-dev [hurd-i386],
 hurd-dev (>= 1:0.5.git20140320~) [hurd-i386] <!stage1> | libihash-dev [hurd-i386] <!stage1>,
 kfreebsd-kernel-headers [kfreebsd-any],
 binutils (>= 2.21),
 g++-6, g++-6-multilib [amd64 i386 kfreebsd-amd64 mips mipsel mipsn32 mipsn32el mips64 mips64el powerpc ppc64 s390x sparc sparc64 x32],
 g++-6 (>= 6.1.1-1~) [hurd-i386 i386 kfreebsd-i386],
 libc-bin (>= 2.24) <cross>
Build-Depends-Indep: perl, po-debconf (>= 1.0)
Maintainer: GNU Libc Maintainers <debian-glibc@lists.debian.org>
Uploaders: Clint Adams <clint@debian.org>, Aurelien Jarno <aurel32@debian.org>, Adam Conrad <adconrad@0c3.net>, Samuel Thibault <sthibault@debian.org>
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-glibc/glibc.git
Vcs-Git: https://anonscm.debian.org/git/pkg-glibc/glibc.git
Homepage: http://www.gnu.org/software/libc/libc.html
XS-Testsuite: autopkgtest

Package: libc-bin
Architecture: any
Section: libs
Priority: required
Essential: yes
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages
Build-Profiles: <!stage1>
Description: GNU C Library: Binaries
 This package contains utility programs related to the GNU C Library.
 .
  * catchsegv: catch segmentation faults in programs
  * getconf: query system configuration variables
  * getent: get entries from administrative databases
  * iconv, iconvconfig: convert between character encodings
  * ldd, ldconfig: print/configure shared library dependencies
  * locale, localedef: show/generate locale definitions
  * tzselect, zdump, zic: select/dump/compile time zones

Package: libc-dev-bin
Architecture: any
Section: libdevel
Priority: optional
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: manpages, manpages-dev
Build-Profiles: <!stage1>
Description: GNU C Library: Development binaries
 This package contains utility programs related to the GNU C Library
 development package.

Package: libc-l10n
Architecture: all
Section: localization
Priority: standard
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: locales (<< 2.21-1)
Replaces: locales (<< 2.21-1)
Build-Profiles: <!stage1>
Description: GNU C Library: localization files
 This package contains the translation files for the GNU C library and
 utility programs.

Package: glibc-doc
Architecture: all
Section: doc
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: glibc-doc-reference
Build-Profiles: <!stage1>
Description: GNU C Library: Documentation
 Contains man pages for libpthread functions and the complete GNU C Library
 ChangeLog.  The GNU C Library Reference manual has been moved into
 glibc-doc-reference for licensing reasons.

Package: glibc-source
Architecture: all
Section: devel
Priority: optional
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: xz-utils
Conflicts: eglibc-source
Replaces: eglibc-source
Build-Profiles: <!stage1>
Description: GNU C Library: sources
 This package contains the sources and patches which are needed to
 build glibc.

Package: locales
Architecture: all
Section: localization
Priority: standard
Depends: libc-bin (>> 2.24), libc-l10n (>> 2.24), ${misc:Depends}, debconf | debconf-2.0
Replaces: manpages-fr-extra (<< 20141022)
Build-Profiles: <!stage1>
Description: GNU C Library: National Language (locale) data [support]
 Machine-readable data files, shared objects and programs used by the
 C library for localization (l10n) and internationalization (i18n) support.
 .
 This package contains tools to generate locale definitions from source
 files (included in this package). It allows you to customize which
 definitions actually get generated. This is a space-saver over how this
 package used to be, with all locales generated by default. This created
 a package that unpacked to an excess of 30 megs.

Package: locales-all
Architecture: any
Section: localization
Priority: extra
Multi-Arch: foreign
Depends: libc-l10n (>> 2.24), ${misc:Depends}
Breaks: locales (<< 2.13-17)
Build-Profiles: <!stage1>
Description: GNU C Library: Precompiled locale data
 This package contains the precompiled locale data for all supported locales.
 A better alternative is to install the locales package and only select
 desired locales, but it can be useful on a low-memory machine because some
 locale files take a lot of memory to be compiled.

Package: nscd
Architecture: any
Section: admin
Multi-Arch: foreign
Priority: optional
Depends: lsb-base (>= 3.0-6), ${shlibs:Depends}, ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Name Service Cache Daemon
 A daemon which handles passwd, group and host lookups
 for running programs and caches the results for the next
 query. You should install this package only if you use
 slow services like LDAP, NIS or NIS+.

Package: multiarch-support
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
	 libc6 (>= 2.3.6-2) [!any-i386 !alpha !armhf !hurd-any !kfreebsd-any],
         libc6.1 (>= 2.3.6-2) [alpha],
         libc0.3 (>= 2.3.6-2) [!linux-any !kfreebsd-any !hurd-i386],
         libc0.1 (>= 2.3.6-2) [!linux-any !hurd-any !kfreebsd-i386],
         libc6 (>= 2.13-5) [armhf i386],
         libc0.3 (>= 2.13-5) [hurd-i386],
         libc0.1 (>= 2.13-5) [kfreebsd-i386],
Priority: required
Build-Profiles: <!stage1>
Description: Transitional package to ensure multiarch compatibility
 This is a transitional package used to ensure multiarch support is present
 in ld.so before unpacking libraries to the multiarch directories.  It can
 be removed once nothing on the system depends on it.

Package: libc6
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el nios2 powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh3 sh4 x32
Section: libs
Priority: required
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-i386]
Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
Conflicts: libc6-loongson2f [mipsel]
Breaks: nscd (<< 2.24), locales (<< 2.24), locales-all (<< 2.24), lsb-core (<= 3.2-27) [amd64 ppc64 sparc64], libx11-6 (<< 1.1.4-2) [hurd-i386], libpthread-stubs0 (<< 0.3-4) [hurd-i386], hurd (<< 1:0.5.git20140203-1), libtirpc1 (<< 0.2.3)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.1-i686 [kfreebsd-i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-x32 [x32],
          libc0.1-i386 [kfreebsd-i386],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.

Package: libc6-dev
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el nios2 powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Depends: libc6 (= ${binary:Version}), libc-dev-bin (= ${binary:Version}), ${misc:Depends}, ${libc-dev:Depends}, kfreebsd-kernel-headers (>= 0.11) [kfreebsd-any], gnumach-dev [hurd-i386], hurd-dev (>= 20080607-3) [hurd-i386] | hurd-headers-dev [hurd-i386]
Replaces: hurd-dev (<< 20120408-3) [hurd-i386]
Suggests: glibc-doc, manpages-dev
Provides: libc-dev, libc6-dev [alpha hurd-i386 kfreebsd-i386 kfreebsd-amd64]
Breaks: binutils (<< 2.26), binutils-gold (<< 2.20.1-11), cmake (<< 2.8.4+dfsg.1-5), gcc-4.4 (<< 4.4.6-4), gcc-4.5 (<< 4.5.3-2), gcc-4.6 (<< 4.6.0-12), make (<< 3.81-8.1), pkg-config (<< 0.26-1), libjna-java (<< 3.2.7-4), liblouis-dev (<< 2.3.0-2), liblouisxml-dev (<< 2.4.0-2), libhwloc-dev (<< 1.2-3), check (<< 0.9.10-6.1+b1) [s390x]
Conflicts: libc6.1-dev, libc0.1-dev, libc0.3-dev,
Description: GNU C Library: Development Libraries and Header Files
 Contains the symlinks, headers, and object files needed to compile
 and link programs which use the standard C library.

Package: libc6-dbg
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el nios2 powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh3 sh4 x32
Section: debug
Priority: extra
Multi-Arch: same
Provides: libc-dbg
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: detached debugging symbols
 This package contains the detached debugging symbols for the GNU C
 library.

Package: libc6-pic
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el nios2 powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh3 sh4 x32
Section: libdevel
Priority: optional
Multi-Arch: same
Conflicts: libc-pic
Provides: libc-pic, glibc-pic
Depends: libc6 (= ${binary:Version}), ${misc:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: PIC archive library
 Contains an archive library (ar file) composed of individual shared objects.
 This is used for creating a library which is a smaller subset of the
 standard libc shared library. The reduced library is used by debian-installer
 and may be useful for custom installation media and in embedded systems.

Package: libc6-udeb
Package-Type: udeb
Architecture: amd64 arm64 armel armhf hppa i386 m68k mips mipsel mipsn32 mipsn32el mips64 mips64el nios2 powerpc powerpcspe ppc64 ppc64el sparc sparc64 s390x sh3 sh4 x32
Section: debian-installer
Priority: extra
Provides: libc6, libc-udeb, libnss-dns-udeb, libnss-files-udeb, ${locale-compat:Depends}
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries - udeb
 Contains the standard libraries that are used by nearly all programs on
 the system. This package includes shared versions of the standard C library
 and the standard math library, as well as many others.
 .
 This package contains a minimal set of libraries needed for the Debian
 installer.  Do not install it on a normal system.

Package: libc6.1
Architecture: alpha
Section: libs
Priority: required
Multi-Arch: same
Depends: ${shlibs:Depends}, ${libgcc:Depends}
Suggests: glibc-doc, debconf | debconf-2.0, libc-l10n, locales [!hurd-i386]
Provides: libc6-sparcv9b [sparc sparc64], libc0.1-i686 [kfreebsd-i386], libc0.3-i686 [hurd-i386], libc6-i686 [i386]
Conflicts: libc6-loongson2f [mipsel]
Breaks: nscd (<< 2.24), locales (<< 2.24), locales-all (<< 2.24), lsb-core (<= 3.2-27) [amd64 ppc64 sparc64], libx11-6 (<< 1.1.4-2) [hurd-i386], libpthread-stubs0 (<< 0.3-4) [hurd-i386], hurd (<< 1:0.5.git20140203-1), libtirpc1 (<< 0.2.3)
Replaces: libc6-amd64 [amd64],
          libc6-i386 [i386],
          libc0.1-i686 [kfreebsd-i386],
          libc0.3-i686 [hurd-i386],
          libc6-i686 [i386],
          libc6-x32 [x32],
          libc0.1-i386 [kfreebsd-i386],
          libc6-powerpc [powerpc],
          libc6-ppc64 [ppc64],
          libc6-s390x [s390x],
          libc6-sparc64 [sparc64],
          libc6-mips64 [mips64 mips64el],
          libc6-mipsn32 [mipsn32 mipsn32el],
          libc6-mips32 [mips mipsel],
          hurd (<< 20120408-3) [hurd-i386]
Build-Profiles: <!stage1>
Description: GNU C Library: Shared libraries

=== debian/rules ===
#! /usr/bin/make -f
# -*- makefile -*-
# debian/rules file for GNU libc.
# Copyright 1998, 1999 by Joel Klecker <espy@debian.org>
# Copyright 2000 Ben Collins <bcollins@debian.org>
# Copyright 2003 Jeff Bailey <jbailey@debian.org>
# This Makefile is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# What are the phases to building glibc?

# Unpack main tarball
# Do any necessary overlays
# Apply patches
# Determine how many builds there are to do.  For Each build:

#  Create build directory
#  Configure
#  Build
#  Test as desired
#  Install to package directories

# Run debian magic to build packages.

# Things you may need to customise:

# These are done as absolute paths so that in the case of filesystem size
# limitations, they can be overridden and spread all over.
build-tree := build-tree
stamp := $(CURDIR)/stamp-dir/
DUMMY := $(shell mkdir -p $(stamp))

# Beyond here you shouldn't need to customise anything:
export SHELL          = /bin/bash -e

DEB_HOST_ARCH         ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_ARCH_ENDIAN  ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_ENDIAN)
DEB_HOST_ARCH_OS      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_TYPE     ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH    ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_ARCH        ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_BUILD_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))

DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
GLIBC_VERSION = $(shell echo $(DEB_VERSION) | sed -e 's/.*://' -e 's/[+-].*//')

SOURCE_DATE_EPOCH ?= $(shell dpkg-parsechangelog -STimestamp)

# The minimum package version with which these packages are compatible.
shlib_dep_ver = $(GLIBC_VERSION)
shlib_dep = $(libc) (>= $(shlib_dep_ver))

DEB_BUILDDIR ?= $(build-tree)/$(DEB_HOST_ARCH)-$(curpass)
DEB_BUILDDIRLIBC ?= $(build-tree)/$(DEB_HOST_ARCH)-libc

GLIBC_SOURCES = $(addprefix $(shell basename $(CURDIR))/, \
		 $(filter-out debian $(shell basename $(stamp)) $(build-tree), $(wildcard *)))
		 
# Support multiple makes at once based on number of processors
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# use the package settings, not the settings from the environment
define unsetenv
  unexport $(1)
  $(1) =
endef
$(foreach v, CPPFLAGS CFLAGS CXXFLAGS LDFLAGS, $(if $(filter environment,$(origin $(v))),$(eval $(call unsetenv, $(v)))))

# Default setup
GLIBC_PASSES ?= libc

prefix=/usr
bindir=$(prefix)/bin
datadir=$(prefix)/share
complocaledir=$(prefix)/lib/locale
sysconfdir=/etc
libexecdir=$(prefix)/lib
rootsbindir=/sbin
includedir=$(prefix)/include
docdir=$(prefix)/share/doc
mandir=$(prefix)/share/man
sbindir=$(prefix)/sbin
vardbdir=/var/lib/misc
rtlddir=/lib
slibdir=/lib/$(DEB_HOST_MULTIARCH)
libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
mvec = no


BASE_CC = gcc
BASE_CXX = g++
BASE_MIG = mig
DEB_GCC_VERSION ?= -6

RUN_TESTSUITE = yes

# Set cross and native compiler names, including version.
CC     = $(DEB_HOST_GNU_TYPE)-$(BASE_CC)$(DEB_GCC_VERSION) -no-pie -fno-PIE
CXX    = $(DEB_HOST_GNU_TYPE)-$(BASE_CXX)$(DEB_GCC_VERSION) -no-pie -fno-PIE
MIG    = $(DEB_HOST_GNU_TYPE)-$(BASE_MIG)
BUILD_CC = $(DEB_BUILD_GNU_TYPE)-$(BASE_CC)
BUILD_CXX = $(DEB_BUILD_GNU_TYPE)-$(BASE_CXX)

BUILD_CFLAGS = -O2 -g
HOST_CFLAGS = -pipe -O2 -g $(call xx,extra_cflags)

configure_target := $(DEB_HOST_GNU_TYPE)

# Normally we'll just use this for --build.  If the architecture requires
# that build daemons be able to run a particular optimized library, then
# they can set the --build to match --host for that optimized build.
# Among other things this lets tests run.
configure_build := $(DEB_BUILD_GNU_TYPE)

log_build    = $(build-tree)/log-build-$(call xx,configure_target)-$(curpass)
log_test     = $(build-tree)/log-test-$(call xx,configure_target)-$(curpass)
log_results  = $(build-tree)/test-results-$(call xx,configure_target)-$(curpass)
log_expected = debian/testsuite-checking/expected-results-$(call xx,configure_target)-$(curpass)

# Which build pass are we on?
curpass = $(filter-out %_,$(subst _,_ ,$@))

# Provide backward compatibility for the old DEB_STAGE and DEB_BUILD_PROFILE for now
ifeq ($(DEB_STAGE),stage1)
  DEB_BUILD_PROFILES+=stage1
else
ifeq ($(DEB_BUILD_PROFILE),bootstrap)
  DEB_BUILD_PROFILES+=stage1
endif
endif

ifneq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  DEB_ARCH_REGULAR_PACKAGES = $(libc)-dev
  DEB_INDEP_REGULAR_PACKAGES = 
  DEB_UDEB_PACKAGES = 
else
  DEB_ARCH_REGULAR_PACKAGES = $(libc) $(libc)-dev $(libc)-dbg $(libc)-pic libc-bin libc-dev-bin multiarch-support
  DEB_INDEP_REGULAR_PACKAGES = glibc-doc glibc-source libc-l10n locales
  DEB_UDEB_PACKAGES = $(libc)-udeb
  ## Locales can only be pre-generated during native compiles
  ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
    DEB_ARCH_REGULAR_PACKAGES += locales-all
  endif
endif

# Generic kernel version check
define kernel_check
(if [ $(CURRENT_KERNEL_VERSION) -lt $(1) ]; then \
  false; \
fi)
endef

# Include libidn for both NPTL and FBTL targets.
standard-add-ons = libidn,

# Pull in all the per-arch magic!

-include debian/sysdeps/$(DEB_HOST_ARCH_OS).mk
-include debian/sysdeps/$(DEB_HOST_ARCH).mk

ifeq ($(filter nobiarch,$(DEB_BUILD_PROFILES)),)
GLIBC_PASSES += $(GLIBC_MULTILIB_PASSES)
DEB_ARCH_REGULAR_PACKAGES += $(DEB_ARCH_MULTILIB_PACKAGES)
endif

# Don't run dh_strip on this package
NOSTRIP_$(libc)-dbg = 1

# Don't put debug files from these packages in libc-dbg
NODEBUG_libc-bin = 1
NODEBUG_libc-dev-bin = 1
NODEBUG_libc0.1-i386 = 1
NODEBUG_libc6-amd64 = 1
NODEBUG_libc6-i386 = 1
NODEBUG_libc6-x32 = 1
NODEBUG_libc6-mips32 =1
NODEBUG_libc6-mips64 = 1
NODEBUG_libc6-mipsn32 = 1
NODEBUG_libc6-powerpc = 1
NODEBUG_libc6-ppc64 = 1
NODEBUG_libc6-s390 = 1
NODEBUG_libc6-sparc64 = 1
NODEBUG_nscd = 1

ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
  ifeq ($(threads),yes)
  DEB_ARCH_REGULAR_PACKAGES += nscd
  endif
endif

# And now the rules...
include debian/rules.d/*.mk

clean:: unpatch
	rm -f $(CURDIR)/po/*.mo
	rm -rf $(patsubst %,debian/tmp-%,$(GLIBC_PASSES))
	rm -rf $(build-tree)
	rm -rf $(stamp)
	rm -rf debian/include
	rm -f debian/control.in/libc0.1 debian/control.in/libc0.3 \
		debian/control.in/libc6 debian/control.in/libc6.1 \
		debian/*.preinst.* debian/locales.bug-presubj

# Required Debian targets
build-arch: $(stamp)info \
	$(patsubst %,$(stamp)build_%,$(GLIBC_PASSES)) \
	$(patsubst %,$(stamp)check_%,$(GLIBC_PASSES))
ifeq ($(filter stage1,$(DEB_BUILD_PROFILES)),)
build-arch: $(stamp)build_C.UTF-8 \
	$(stamp)build_locales-all
endif

build-indep: $(stamp)source

build: build-arch build-indep


binary-indep: build-indep testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_INDEP_REGULAR_PACKAGES))

binary-arch: build-arch testroot debian/control $(build-tree) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_ARCH_REGULAR_PACKAGES)) \
	$(patsubst %,$(stamp)binaryinst_%,$(DEB_UDEB_PACKAGES))

binary: binary-indep binary-arch

testroot:
	dh_testroot

=== debian/tests/control ===
Tests: rebuild
Depends: @builddeps@, fakeroot, binutils, linux-libc-dev [linux-any], gcc-6
Restrictions: allow-stderr
